/* @(#)61  1.8  include/m6libhdr.h, m6co_headers, sco_3.0, 301FCS 9/9/94 13:04:33, SecureWare, Inc. */

/* m6libhdr.h
 *
 * This file contains all of the standard header information needed by the
 * libm6 library routines.
 *
 */

#ifndef __M6LIBHDR__
#define __M6LIBHDR__

#include "sys/secdefines.h"

#if SEC_MSIX_IPC /*{*/

#include "sys/types.h"
#include "stdio.h"
#include "errno.h"

#include "sys/socket.h"
#if SEC_MSIX_STREAMS
#include "sys/stream.h"
#include "sys/stropts.h"
#include "sys/tiuser.h"
#include "sys/timod.h"
#endif
#if defined(SCO_3) || !defined(SCO)
#include "sys/uio.h"
#include "sys/ioctl.h"
#endif

#include "sys/security.h"
#include "sys/secpolicy.h"
#include "mandatory.h"
#include "acl.h"
#include "sys/sctntypes.h"
#include "sys/sctnmasks.h"
#include "sys/sctnattrs.h"
#include "sys/scauth.h"
#include "sys/scsockopts.h"
#include "m6attrs.h"
#include "prot.h"

/*
 * These macros round their first argument up to the next higher multiple
 * of their second argument.  The second argument must be a power of 2.
 * The ALIGN_NUM macro is for rounding integer types, while the ALIGN_PTR
 * macro handles rounding of pointer types.
 */

#define	ALIGN_NUM(n,b)		(((n) + (b) - 1) & ~((b) - 1))
#define	ALIGN_PTR(p,b,t)	(t) (((u_long) (p) + (b) - 1) & ~((b) - 1))


/* Pointer to the buffer used for building/scanning attribute sets. */
extern struct 	m6_sec_attr *sec_attr;
extern int	attr_size;
#define CHECK_SEC_ATTR(attr_ptr, attr_ptr_size) \
	if ((attr_ptr) == NULL) { \
		if (((attr_ptr) = (struct m6_sec_attr *)m6sec_attr_alloc()) \
		    == NULL) { \
			errno = ENOMEM; \
			return(-1); \
		} \
		else	(attr_ptr_size) = (attr_ptr)->hdr.length; \
	} \
	else \
		(attr_ptr)->hdr.length = (attr_ptr_size);

#endif /* SEC_MSIX_IPC }*/
#endif /* __LIBM6HDR__ */
